package com.caimei365.tools.controller;

import com.caimei365.tools.model.ResponseJson;
import com.caimei365.tools.service.*;
import com.caimei365.tools.service.impl.SysUserServiceImpl;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2021/5/18
 */
@RestController
@RequiredArgsConstructor
@RequestMapping("/tools")
@Slf4j
public class BaseApi {

    @Resource
    private CmOrganValueSystemService cmOrganValueSystemService;
    @Resource
    private CmRepurchaseFrequencyService cmRepurchaseFrequencyService;
    @Resource
    private CmBehaviorRecordService cmBehaviorRecordService;
    @Resource
    private CmVipCouponService cmVipCouponService;
    @Resource
    private SysUserServiceImpl sysUserService;
    @Resource
    private WeChatService weChatService;

    @Resource private MessageService messageService;

    @Value(value = "${swagger.enabled}")
    private Boolean swaggerEnabled;


    @GetMapping("")
    public String welcome() {
        if (swaggerEnabled) {
            return "欢迎使用！<br><a href='http://47.119.112.46:18013/doc.html'>doc接口文档入口(beta)</a><br><a href='http://47.119.112.46:18013/swagger-ui/index.html'>swagger接口文档入口(beta)</a>";
        }
        return "欢迎使用！";
    }

    @GetMapping("/new/token")
    public String getNewToken(String id) {
        return sysUserService.getNewToken(id);
    }

    /**
     * 用户活跃
     */
    /*@GetMapping("/record/update")
    public void svipCoupon() throws IOException {
//        cmVipCouponService.openCoupon();
//        cmBehaviorRecordService.updateClubAddress(startId, endId);
        cmOrganValueSystemService.insertOrgan();
    }*/

    /**
     * 用户价值
     */
    /*@GetMapping("/record/getData")
    public void getData(){
        cmOrganValueSystemService.insertcustomer();
    }*/

    /**
     * 合并ip
     */
    /*@GetMapping("/record/getBehavior")
    public void getBehavior(){
        cmBehaviorRecordService.updateBehaviorUser();
    }*/

    /**
     * 协销信息提醒
     */
    /*@GetMapping("/record/message")
    public void getMessage(){
        messageService.UnActiveMessage();
    }*/

    /**
     * 临时接口
     */
    /*@GetMapping("/base/oldData")
    public void oldData(String startTime, String endTime) {
//        cmBehaviorRecordService.pageStatistics(dateTime);
//        cmBehaviorRecordService.insertTodayData();
        cmBehaviorRecordService.clubDemand(startTime, endTime);
    }*/

    @ApiOperation("获取小程序二维码图片")
    @PostMapping("/wxacode")
    public ResponseJson<String> generateWxacode(@RequestBody String params) throws Exception {
        ResponseJson<String> result = weChatService.generateWxacode(params);
        return result;
    }
}

