package com.caimei365.tools.listener;

import com.caimei365.tools.mapper.CmBehaviorTouristInfoDao;
import com.caimei365.tools.model.po.CmBehaviorTouristInfoPo;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.apache.rocketmq.spring.core.RocketMQListener;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/11/1
 */
@Slf4j
@Component
@RocketMQMessageListener(
        topic = "Tourist",
        consumerGroup = "tourist_group"
)
public class TouristLine implements RocketMQListener<String> {

    @Resource private CmBehaviorTouristInfoDao cmBehaviorTouristInfoDao;

    @Override
    public void onMessage(String tourist) {
        CmBehaviorTouristInfoPo touristInfo = new CmBehaviorTouristInfoPo();
        touristInfo.setTouristId(tourist);
        cmBehaviorTouristInfoDao.insertTourist(touristInfo);
    }
}
