package com.caimei365.tools.model.dto.message;


import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.experimental.Accessors;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotNull;

@Data
@Accessors(fluent = true)
@NoArgsConstructor
@ToString
public class EmailMessage {
    /**
     * 邮件主题
     */
    @NotNull
    private String subject;
    /**
     * 收件人地址
     */
    @NotNull
    @Email
    private String receiverAddress;
    /**
     * 内容
     */
    @NotNull
    private String emailMessageContent;
    /**
     * 抄送地址
     */
    private String[] cc;

    public EmailMessage cc(String cc) {
        this.cc = new String[]{cc};
        return this;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getReceiverAddress() {
        return receiverAddress;
    }

    public void setReceiverAddress(String receiverAddress) {
        this.receiverAddress = receiverAddress;
    }

    public String getEmailMessageContent() {
        return emailMessageContent;
    }

    public void setEmailMessageContent(String emailMessageContent) {
        this.emailMessageContent = emailMessageContent;
    }

    public String[] getCc() {
        return cc;
    }

    public void setCc(String[] cc) {
        this.cc = cc;
    }
}
