package com.caimei365.tools.model.po;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import java.io.Serializable;
import lombok.Data;
import lombok.experimental.Accessors;
import org.apache.ibatis.type.Alias;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.util.Date;

/**
 * 会所资料信息对象 club
 *
 * @author Kaick
 * @date 2023-08-31
 */
@Accessors(chain  = true )
@Data
@Alias("ClubPo")
public class ClubPo implements Serializable
{
    private static final long serialVersionUID = 1L;

    /** 会所ID */
    private String clubID;

    /** 用户ID */
    private Integer userID;

    /** 会所名称 */
    private String name;

    /** 简称 */
    private String sname;

    /** logo */
    private String logo;

    /** 法人 */
    private String legalPerson;

    /** 省 */
    private Integer provinceID;

    /** 市 */
    private Integer cityID;

    /** 地址ID */
    private Integer townID;

    /** 拉会所上线的用户的cmBindId,以逗号结尾 */
    private String flag;

    /** 邀请者cmBindId */
    private Integer inviterBindID;

    /** 邀请者名称 */
    private String inviterName;

    /** 协销Id */
    private Integer spID;

    /** 协销经理Id */
    private Integer mainServiceProviderID;

    /** 扫描时间 */
    private String scanTime;

    /** 详细地址 */
    private String address;

    /** 联系人 */
    private String linkMan;

    /** 联系人身份：1老板，2采购，3运营，4其他 */
    private Integer linkManIdentity;

    /** 联系电话 */
    private String contractPhone;

    /** 联系手机 */
    private String contractMobile;

    /** 联系邮箱 */
    private String contractEmail;

    /** 传真 */
    private String fax;

    /** 公司简介 */
    private String info;

    /** 注册时间 */
    private String addTime;

    /** 审核时间 */
    private String auditTime;

    /** 审核备注 */
    private String auditNote;

    /** 状态 */
    private Integer status;

    /** 营业执照 */
    private String businessLicenseImage;

    /** 默认的创客 */
    private Integer defaultServiceProviderID;

    /** 创客更新时间 */
    private String defaultServiceProviderUpdTime;

    /** 主打项目 */
    private String mainpro;

    /** 扫描状态 0待扫描 1 已扫描 2已上线 */
    private String scanFlag;

    /** 门头照 */
    private String headpic;

    /** 最后更新时间 */
    private String lastModify;

    /** 最后查看订单时间(用于协销统计历史订单未查看数量) */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastCheckOrderDate;

    /** 统一社会信用代码 */
    private String socialCreditCode;

    /** 一级分类为医美=1和生美=2 */
    private String firstClubType;

    /** 医美的二级分类为诊所=1、门诊=2、医院=3。  生美没有二级分类 */
    private String secondClubType;

    /** 若为医美分类下的门诊和医院则需要填写科室。 */
    private String department;

    /** 医美分类必须上传医疗执业许可证 */
    private String medicalPracticeLicenseImg;

    /** 审核人 */
    private String checkMan;

    /** $column.columnComment */
    private Integer newDeal;

    /** $column.columnComment */
    private Integer empnum;

}

