package com.caimei365.tools.model.po;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 优惠券管理Entity
 *
 * @author plf
 * @version 2021-08-02
 */
@Data
@ToString
public class CmCouponPo implements Serializable {

    private static final long serialVersionUID = 1L;
    private Integer id;
    private String name;        // 活动主题
    private BigDecimal couponAmount;        // 优惠券金额(面值)
    private BigDecimal touchPrice;        // 优惠满减条件金额
    private Date startDate;        // 使用开始时间（有效期）
    private Date endDate;        // 使用结束时间（有效期）
    private Integer receivePeriod;		// 领取期限（天）
    private Integer useTimeFlag;		// 领取期限同开始-开始时间
    private Integer receiveFlag;		// 领取期限同开始-结束时间
    private Integer usePeriod;		// 使用期限（天）
    private String status;        // 状态 0未生效 1已生效 2已关闭 3已失效
    private Integer couponType;        // 劵类型 0活动券 1品类券 2用户专享券 3店铺券 4新用户券
    private Integer vipFlag;        // 超级会员专享优惠券标志：0否，1是
    private Integer userId;     //机构用户id(用户专享券有效)
    private Integer shopId;     //供应商id(店铺券有效)
    private String productType;        // 优惠商品：1全商城商品 2指定商品(活动券有效)
    private String pcBanner;        //网站活动页banner
    private String appletsBanner;       //小程序活动页banner
    private String categoryType;        // 优惠品类：1产品 2仪器(品类券有效)
    private String couponsMode;        // 领券方式：0正常 1使用兑换码
    private String productInfo;        //商品json数据
    private String clubName;           //机构名称
    private String claimStatus;         //领取状态：1未领取 2已领取
    private String useStatus;       //使用状态 1未使用 2已使用
    private String source;      //领取渠道：1小程序 2网站 3订单退回
    private String shopName;        //供应商名称
    private Integer codeNum;       //兑换码数量
    private Integer clubCouponId;      //机构领券id
    private String couponName;          //优惠券名称
    private String couponDesc;        //描述
    private String redemptionCode;      //兑换码
    private Integer moneyCouponType; //价值优惠券属性 1,意向券，2，定向券
    private Integer moneyCouponFlag; //是否是价值优惠券，1是，2不是
    private Double moneyCouponPrice; //价值优惠券购买金额
    private List<Integer> productIdList;
    private Integer couponPayWay;  //购买方式 1.直接购买 2.采美豆抵扣
    private Integer clubId; //领取人的clubId
    private String bindMobile;//领取人手机号

    private Date receiveDate;   // 领取时间
    private Date useEndDate;    // 使用截止时间
    private String delFlag;    // 删除标记
    private Date createDate;    // 创建时间
    private Integer configure;  // 专属优惠券配置 1是、0否
}
