package com.caimei365.tools.utils;

import com.alibaba.fastjson.JSONObject;

import com.caimei365.tools.model.dto.message.WechatTemplateMessage;
import com.caimei365.tools.model.dto.message.enums.WechatType;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

@Component
@Slf4j
public class WeChatUtil {
    public void sendMessage(WechatTemplateMessage wechatTemplateMessage){
        try {
            WechatType wechatType = WechatType.initWechatType(wechatTemplateMessage.getType());
            String requestUrl = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + getAccessToken(wechatType);
            // 发送请求
            String json = wechatTemplateMessage.getJson();
            log.info("微信发消息的-------------------------->"+json);
            String result = RequestUtil.httpRequest(requestUrl, "POST", json);
            log.info(">>>>>>>>微信模板消息推送结果：" + result);
        } catch (Exception e) {
            log.error("推送微信模板消息失败：" + e);
        }
    }

    public static String getAccessToken(WechatType wechatType) throws Exception {
        String link = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=APPID&secret=APPSECRET";
        link = link.replace("APPID", wechatType.getAPPID());
        link = link.replace("APPSECRET", wechatType.getAPPSECRET());
        String result = RequestUtil.sendGet(link);
        log.info("微信公众号获取access_token>>>" + result);
        Map<String, Object> map = JSONObject.parseObject(result, Map.class);
        String access_token = (String) map.get("access_token");
        return access_token;
    }

}
